searchData={"items":[{"type":"module","title":"Please","doc":"Documentation for `Please`.\n\nThis module will handle requests from nodes in the network and route them to\nthe correct node that can handle the request. The module will also keep track\nof the nodes in the network and their capabilities to handle requests.","ref":"Please.html"},{"type":"function","title":"Please.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Please.html#child_spec/1"},{"type":"macro","title":"Please.make_it_so/4","doc":"Makes a request to the network. The default timeout is 5000 milliseconds and\ncan be changed by passing the `timeout` option.","ref":"Please.html#make_it_so/4"},{"type":"macro","title":"Examples - Please.make_it_so/4","doc":"iex> Please.make_it_so(MyModule, :my_function, [1, 2, 3])\n    {:ok, function_output, :\"some@other.node\"}","ref":"Please.html#make_it_so/4-examples"},{"type":"function","title":"Please.start_link/1","doc":"","ref":"Please.html#start_link/1"},{"type":"module","title":"Please.Nodes","doc":"An agent listing nodes in the network and the requests they can handle. It\nalso keeps track of the busyness of the current node and it's name.\n\nThe `key` is the atom node name of the node. The `value` must be a metadata\nmap.\n\nThis dictionary is built from remote nodes that are connected to the network,\nand will be stored in a map handled in this module acting as an Agent.","ref":"Please.Nodes.html"},{"type":"function","title":"Please.Nodes.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Please.Nodes.html#child_spec/1"},{"type":"function","title":"Please.Nodes.get/0","doc":"Get the metadata of all nodes.","ref":"Please.Nodes.html#get/0"},{"type":"function","title":"Please.Nodes.get/1","doc":"Get the metadata of a node.","ref":"Please.Nodes.html#get/1"},{"type":"function","title":"Please.Nodes.metadata/0","doc":"","ref":"Please.Nodes.html#metadata/0"},{"type":"function","title":"Please.Nodes.referrals/0","doc":"Get the referrals from the configuration.\n\nThe referrals are a comma-separated list of atoms that represent the nodes\nthat are connected to the network. This list is used to build the initial\nstate of the agent, filtering out the nodes that are not reachable.","ref":"Please.Nodes.html#referrals/0"},{"type":"function","title":"Please.Nodes.rpc/4","doc":"Make a remote procedure call to a node.\n\nThis function will call a function of a module in the given node with\noptional arguments.","ref":"Please.Nodes.html#rpc/4"},{"type":"function","title":"Please.Nodes.set/1","doc":"Set this node metadata","ref":"Please.Nodes.html#set/1"},{"type":"function","title":"Please.Nodes.set/2","doc":"Set the node metadata","ref":"Please.Nodes.html#set/2"},{"type":"function","title":"Please.Nodes.start_link/1","doc":"Start the agent.","ref":"Please.Nodes.html#start_link/1"},{"type":"module","title":"Please.Nodes.PingTask","doc":"A task that pings the node network.\n\nThis task will ping the nodes in the network and update the state of the\nagent with the nodes that are reachable. The task will also update the state\nof the agent with the metadata of the nodes that are reachable.\n\nThe ping latency can be configured with the `:latency` option of the `:ping`\nkey in the application configuration (in milliseconds), the default is 1500\nmilliseconds.","ref":"Please.Nodes.PingTask.html"},{"type":"function","title":"Please.Nodes.PingTask.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\n`arg` is passed as the argument to `Task.start_link/1` in the `:start` field\nof the spec.\n\nFor more information, see the `Supervisor` module,\nthe `Supervisor.child_spec/2` function and the `t:Supervisor.child_spec/0` type.","ref":"Please.Nodes.PingTask.html#child_spec/1"},{"type":"module","title":"Please.Nodes.SyncTask","doc":"A task that sync the node list across the network.\n\nThis task will sync the nodes in the network and update the state of the\nagent with the nodes that are reachable.\n\nThe sync latency can be configured with the `:latency` option of the `:sync`\nkey in the application configuration (in milliseconds), the default is 3000\nmilliseconds.","ref":"Please.Nodes.SyncTask.html"},{"type":"function","title":"Please.Nodes.SyncTask.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\n`arg` is passed as the argument to `Task.start_link/1` in the `:start` field\nof the spec.\n\nFor more information, see the `Supervisor` module,\nthe `Supervisor.child_spec/2` function and the `t:Supervisor.child_spec/0` type.","ref":"Please.Nodes.SyncTask.html#child_spec/1"},{"type":"module","title":"Please.Requests","doc":"An agent listing all requests that have been made to the network.\n\nThe first list holds the requests that this node is asking to be resolved,\nwhile the second list holds the requests that this node is resolving itself.\n\nIt's possible to request the busyness of another node in relation to\nperforming a certain request. The other node should return an integer with\nthe priority of the node to handle the request (with any offset applied) or\nnil if the node simply cannot handle the request in any way.\n\nNodes handle their own busyness level, which increases or decreases as they\naccept and finish requests. It is possible to configure the node in such a\nway that certain requests alter the busyness level of the node in varying\nlevels. This way, the node can be configured to prefer certain types of\nrequests over others.","ref":"Please.Requests.html"},{"type":"function","title":"Please.Requests.acceptance_priority/1","doc":"Get the acceptance priority of a given request for the current node.\n\nTo see the documentation of the aceptance_priority function called by the agent\nitself, see the documentation of the function with the same name that takes\ntwo arguments.","ref":"Please.Requests.html#acceptance_priority/1"},{"type":"function","title":"Please.Requests.acceptance_priority/2","doc":"Get the acceptance priority of a given request for a specific node.\n\nThe node can be an atom or a tuple with the node atom and the state map.\n\nThe first case is intended to be used to request the acceptance priority of a\nnode that is not the current node. The second case is intended to be the\nversion of the function that is called by the agent itself when asked\nremotely, as it will have the agent state as the first argument, and the\nrequest as the second argument.","ref":"Please.Requests.html#acceptance_priority/2"},{"type":"function","title":"Please.Requests.add/1","doc":"Add a request.","ref":"Please.Requests.html#add/1"},{"type":"function","title":"Please.Requests.base_busyness/0","doc":"Get the base busyness of the local node.","ref":"Please.Requests.html#base_busyness/0"},{"type":"function","title":"Please.Requests.base_busyness/1","doc":"Get the base busyness of the local node.","ref":"Please.Requests.html#base_busyness/1"},{"type":"function","title":"Please.Requests.base_busyness_decrease/1","doc":"Decrease the base busyness of the local node.","ref":"Please.Requests.html#base_busyness_decrease/1"},{"type":"function","title":"Please.Requests.base_busyness_increase/1","doc":"Increase the base busyness of the local node.","ref":"Please.Requests.html#base_busyness_increase/1"},{"type":"function","title":"Please.Requests.busyness/0","doc":"Get the busyness of the local node.","ref":"Please.Requests.html#busyness/0"},{"type":"function","title":"Please.Requests.busyness_weights/0","doc":"Fetch custom busyness weights for certain modules and functions.","ref":"Please.Requests.html#busyness_weights/0"},{"type":"function","title":"Please.Requests.busyness_weights/1","doc":"Fetch the busyness weight for a request. If the weight is nil, the request\ncan't be handled by the current node. It's possible to configure a rejection\nby setting the weight to `:reject`.","ref":"Please.Requests.html#busyness_weights/1"},{"type":"function","title":"Please.Requests.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Please.Requests.html#child_spec/1"},{"type":"function","title":"Please.Requests.delegate/2","doc":"Delegate a request to another node.","ref":"Please.Requests.html#delegate/2"},{"type":"function","title":"Please.Requests.get/0","doc":"Get all known requests.","ref":"Please.Requests.html#get/0"},{"type":"function","title":"Please.Requests.get/1","doc":"Get a request by its ID.","ref":"Please.Requests.html#get/1"},{"type":"function","title":"Please.Requests.get_handling/0","doc":"Get all handling requests.","ref":"Please.Requests.html#get_handling/0"},{"type":"function","title":"Please.Requests.get_handling/1","doc":"Get a handling request by its ID.","ref":"Please.Requests.html#get_handling/1"},{"type":"function","title":"Please.Requests.get_pending/0","doc":"Get all pending requests.","ref":"Please.Requests.html#get_pending/0"},{"type":"function","title":"Please.Requests.get_pending/1","doc":"Get a pending request by its ID.","ref":"Please.Requests.html#get_pending/1"},{"type":"function","title":"Please.Requests.handle/1","doc":"Handle a request, returning the output to the requester PID.\n\nThe requester will receive a tuple with the module name, the function name,\nthe ID of the request, and the output of the function call, inside a tuple.\n\nIf the function call raises an error, the requester will receive a tuple with\nthe module name, the atom `:error` name, the request itself, and the error\nmessage, inside a tuple.","ref":"Please.Requests.html#handle/1"},{"type":"function","title":"Please.Requests.pick/1","doc":"Pick a request to be handled.","ref":"Please.Requests.html#pick/1"},{"type":"function","title":"Please.Requests.remove/1","doc":"Remove a request.","ref":"Please.Requests.html#remove/1"},{"type":"function","title":"Please.Requests.start_link/1","doc":"Start the agent.","ref":"Please.Requests.html#start_link/1"},{"type":"module","title":"Please.Requests.AssignRequestsTask","doc":"A task that assigns requests around the node network based on busyness and\nacceptance priority of each node.\n\nThis task will run periodically and will assign requests to the nodes in the\nnetwork by checking the acceptance priority of each task for each node.\n\nThe asignation latency can be configured with the `:latency` option of the\n`:assign_requests` key in the application configuration (in milliseconds),\nthe default is 20 milliseconds.","ref":"Please.Requests.AssignRequestsTask.html"},{"type":"function","title":"Please.Requests.AssignRequestsTask.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\n`arg` is passed as the argument to `Task.start_link/1` in the `:start` field\nof the spec.\n\nFor more information, see the `Supervisor` module,\nthe `Supervisor.child_spec/2` function and the `t:Supervisor.child_spec/0` type.","ref":"Please.Requests.AssignRequestsTask.html#child_spec/1"},{"type":"module","title":"Please.Requests.HandleRequestsTask","doc":"A task that will periodically handle the requests assigned to this node.\n\nThe handling latency can be configured with the `:latency` option of the\n`:handle_requests` key in the application configuration (in milliseconds),\nthe default is 10 milliseconds.","ref":"Please.Requests.HandleRequestsTask.html"},{"type":"function","title":"Please.Requests.HandleRequestsTask.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\n`arg` is passed as the argument to `Task.start_link/1` in the `:start` field\nof the spec.\n\nFor more information, see the `Supervisor` module,\nthe `Supervisor.child_spec/2` function and the `t:Supervisor.child_spec/0` type.","ref":"Please.Requests.HandleRequestsTask.html#child_spec/1"},{"type":"module","title":"Please.Requests.Request","doc":"A struct to represent a single request from some node.\n\nThe `id` field is a UUID acting as an unique identifier for the request. The\n`node` field is the atom node name of the node that sent the request and\nhosts the PID of the process that the request response will be sent to.","ref":"Please.Requests.Request.html"},{"type":"function","title":"Please.Requests.Request.new/4","doc":"Create a new request struct. The `from` field will be the atom node name of\nthe current node, and the `id` field will be a new UUID.","ref":"Please.Requests.Request.html#new/4"},{"type":"function","title":"Examples - Please.Requests.Request.new/4","doc":"iex> Please.Request.new(Node, :self)\n    %Please.Request{id:  , from: :nonode@nohost, to: nil, module: Node, function: :self, args: []}","ref":"Please.Requests.Request.html#new/4-examples"},{"type":"type","title":"Please.Requests.Request.t/0","doc":"","ref":"Please.Requests.Request.html#t:t/0"},{"type":"extras","title":"Please","doc":"# Please\n\n\"Oh, I get by with a little help from my friends\"\n\nPlease is a simple Elixir library that provides a way to seamesly balance\nrequests across multiple Elixir nodes. It is designed to be used in a\ndistributed system where multiple nodes are available to handle requests.\nPlease will automatically distribute requests across all available nodes taking\ninto account the amount and weight of the requests each node is currently\nhandling, and if the nodes can handle the task at all.","ref":"readme.html"},{"type":"extras","title":"Usage - Please","doc":"First, you need to start the Please application on all nodes that you want to\nbalance requests across. To do so you may include it in your `mix.exs` file:\n\n```elixir\ndef application do\n  [\n    extra_applications: [:please]\n  ]\nend\n```\n\nThen, use `Please` in your module to be able to make requests to the node\nnetwork.\n\n```elixir\ndefmodule MyModule do\n  use Please\n\n  def my_function do\n    Please.make_it_so(SomeOtherModule, :some_other_function, [:some_arg, :some_other_arg, ...])\n    #=> {:ok, result, remitent_node} || {:error, :timeout}\n  end\nend\n```\n\nThe application will handle node list persistence, node availability, and\nrequest balancing for you. You just need to call `Please.make_it_so` with the\nmodule and function you want to call, and optionally the arguments you want to\npass to it. If a node has such a combination of module, function and arity, it\nwill be elegible to handle the request, and the one with the least amount of\nworkload (based on requests currently being handled) will be chosen to handle\nit.","ref":"readme.html#usage"},{"type":"extras","title":"Configuration - Please","doc":"Please can be configured to always try to connect to a coma-separated list of\nnodes. This referral list can be set in the config files of your application:\n\n```elixir\nconfig :please,\n  referrals: \"node1@localhost,node2@localhost\"\n```\n\nIt's possible to define a metadata map that will be sent to the nodes to keep\nin the node list. This metadata can be freely specified, but is only updated\nonce at connection time. The metadata can be set in the config files of your\napplication:\n\n```elixir\nconfig :please,\n  metadata: %{\"my_key\" => \"my_value\"}\n```\n\nThe weight and offset of specific modules and functions can also be configured\nin the config files of your application:\n\n```elixir\nconfig :please,\n  busyness_weights: %{\n    MyModule: %{my_function: 200}\n  },\n  busyness_offset: %{\n    MyModule: %{my_function: -50}\n  }\n```\n\nThe offset represent how eager a node is to handle a request. A negative offset\nwill make the node more likely to be chosen to handle a request, while a\npositive offset will make it less likely. The weight represents how much work a\nrequest will be for the node. The higher the weight, the less likely the node\nwill be chosen to handle the request if it is handling such a task.\n\nAny unspecified combination of module and function that is defined in the node\nwill have a default weight of 100 and a default offset of 0. The weight and\noffset is used to calculate the busyness of a node by adding the total weight\nof requests currently being handled by the node and then adding the offset. If\nthe custom weight is set to `:reject`, the node will be considered ineligible\nto handle the request even if it has the module and function available.\n\nFor further configuration options, please refer to the documentation of each\nmodule in the `Please` namespace.","ref":"readme.html#configuration"},{"type":"extras","title":"A word of caution - Please","doc":"Such friendship requires a lot of trust. The erlang distribution protocol is\nnot secure, and the nodes will trust each other blindly. Please make sure that\nyou trust all nodes in your network AND the network itself, and that you have\ntaken the necessary precautions to secure your network traffic.\n\nA good practice is to use a VPN to secure the communication between nodes, and\nto use a firewall to restrict the access to the nodes to only the necessary\nports.","ref":"readme.html#a-word-of-caution"},{"type":"extras","title":"Installation - Please","doc":"It's [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `please` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:please, \"~> 0.1.0\"}\n  ]\nend\n```\n\nDocumentation can be found at  .","ref":"readme.html#installation"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}